//@input Asset.Texture[] image {"label": "Images"}
//@input Asset.Texture defaultTex {"label": "Defaul Texture"}

//@input Component.Image bubble

//@input bool advanced = false

//@ui {"widget":"group_start", "label":"Advanced", "showIf": "advanced"}
//@input float delayBetweenImages = 0.1 {"widget":"slider", "min":0.0, "max":1.0, "step":0.01}
//@input float delayBeforeStop = 1.5 {"widget":"slider", "min":0.0, "max":3.0, "step":0.01}

//@input SceneObject objectWithTweens
//@ui {"widget":"group_end"}


var bubblePass = script.bubble.mainMaterial.mainPass;

var n = script.image.length;
var image = script.image;
var curIndex = -1;

var tapTrigger = script.createEvent("TouchStartEvent");
tapTrigger.bind(randomizeStart);

var updateEvent = script.createEvent("UpdateEvent");
updateEvent.bind(updateFunc);

function randomizeStart() {
    // Stop tweening the default image
    global.tweenManager.stopTween(script.objectWithTweens, "ALPHA");
    global.tweenManager.startTween(script.objectWithTweens, "ALPHA-100");
    
    // start randomizing, disable user input
    randomizeStartTime = getTime();
    updateEvent.enabled = true;
    tapTrigger.enabled = false;
}

function updateFunc() {
    var curTime = getTime();

    // If still choosing random image
    if ((curTime - randomizeStartTime) < script.delayBeforeStop) {
        if ((curTime - setImageTime) > script.delayBetweenImages) {
            
            // Prevent selecting the same image twice
            var index = randomInt(n);
            var i = 0;
            while (index == curIndex && i < 10) {
                index = randomInt(n);
                i++;
            }

            setImageTime = curTime;
            
            // Set the displayed image to the selected texture
            bubblePass.baseTex = image[index];
            curIndex = index;
        }
    } else {
        // Play a tween when we've chosen an image'
        if ((curTime - randomizeStartTime) > script.delayBeforeStop - 0.4) {
            global.tweenManager.startTween(script.objectWithTweens, "SCALE");
        }
        
        // Enable user input once we've chosen an image'
        updateEvent.enabled = false;
        tapTrigger.enabled = true;
    }
}

function randomInt(val) {
    return Math.floor(Math.random() * Math.floor(val));
}

function init() {
    setImageTime = 0;
    randomizeStartTime = -1;
    bubblePass.baseTex = script.defaultTex;
    
    // Add some effect so the Lens feels dynamic before the user starts playing
    global.tweenManager.startTween(script.objectWithTweens, "ALPHA");
    
    updateEvent.enabled = false;
}

init()
